//
// See license.txt
//
//--------------------------- ------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//#include <stdlib.h>
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------
const int arraySizeStrings=256;
const int maxIteractions=200;
int arraySizeGenes=5;
float Prec=0.01;
int Maska=16;
float a1=0; float b1=0; float c1=0;

int SubarraySizeStrings;
int RangeFirst=0;
int RangeSecond=0;
float mut_Prob;//=StrToFloat(Form1->Label2->Caption);
float cross_Prob;//=0.85;
int maxDiapason=31;
int TheBest=1;
int TheBestIter=0;
int IterationNumber=0;
AnsiString s;

//------------------------------------------------

int a[maxIteractions][arraySizeStrings+1];
float avr[maxIteractions];
int lastMax[maxIteractions];
int otvetX=0;
float B[maxIteractions][arraySizeStrings+1];
float P[maxIteractions][arraySizeStrings+1];
float Ran[maxIteractions][arraySizeStrings+1];
float Cros[maxIteractions][arraySizeStrings+1];
int CrossPosition[maxIteractions][arraySizeStrings+1];
float MutationProb[maxIteractions][arraySizeStrings+1][16];
//------------------------------------------------

AnsiString binary(int,int);
void generate(int [][arraySizeStrings+1],int,int,int num);
float function1(float);
float function2(float);
float function3(float);
float function4(float);
float max(float[][arraySizeStrings+1],int num);
//int (int[][arraySizeStrings+1],int num);
float sum(float[][arraySizeStrings+1],int num);
void result(int[][arraySizeStrings+1],float[][arraySizeStrings+1],int num);
void ruletka(float[][arraySizeStrings+1],float[][arraySizeStrings+1],int num);
void reproduction(int[][arraySizeStrings+1],float[][arraySizeStrings+1],float[][arraySizeStrings+1],int num);
void crossover(int[][arraySizeStrings+1],float[][arraySizeStrings+1],int[][arraySizeStrings+1],int num);
void mutation(int[][arraySizeStrings+1],float[][arraySizeStrings+1][16],int num);
int start(int iter);
void inputData();
void back(int iter);
void diap();
float max2(float ma[][arraySizeStrings+1]);

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner) {
  // mut_Prob=StrToFloat(Form1->Label2->Caption);
  // cross_Prob=StrToFloat(Form1->Label3->Caption);
  Form1->SG1->Cells[0][0]="Num.";
Form1->SG1->Cells[1][0]="Binary";
Form1->SG1->Cells[2][0]="Dec";
Form1->SG1->Cells[3][0]="Real";
Form1->SG1->Cells[4][0]="Fitness";
Form1->SG1->Cells[0][9]="Max";
Form1->SG1->Cells[0][10]="Sum";
Form1->SG1->Cells[0][11]="Aver";
Form1->SG1->Cells[5][0]="Prob.";
Form1->SG1->Cells[6][0]="Next";
Form1->SG1->Cells[7][0]="NextRand";
Form1->SG1->Cells[8][0]="Crossed";
Form1->SG1->Cells[9][0]="Cross_Prob";
Form1->SG1->Cells[10][0]="Cross_Pos";
Form1->SG1->Cells[11][0]="Mut_Result";
Form1->Button1->Enabled=false;
Form1->Button2->Enabled=false;
Form1->Button5->Enabled=false;
Form1->Button6->Enabled=false;
Form1->ComboBox1->ItemIndex=0;
}
//---------------------------------------------------------------------------

void diap()
{float R=(RangeSecond-RangeFirst)/Prec;
for(int i=0;i<16;i++)
{float j=pow(2,i);
   if(j>R)
        {arraySizeGenes=i;
        Maska=pow(2,i-1);
        maxDiapason=j-1;
         s=AnsiString::StringOfChar('a',i);
        break;
        }
 }
}

 AnsiString binary(int x,int si)
 {  s=AnsiString::StringOfChar('a',si);
 for(int i=1;i<si+1;i++)
 {
    if((x & (Maska >> i-1))==0)
        {s[i]='0';}
    else{s[i]='1';}
 }
 return s;
 }

void inputData()
{

mut_Prob=StrToFloat(Form1->Label2->Caption);
cross_Prob=StrToFloat(Form1->Label3->Caption);
RangeFirst=StrToFloat(Form1->Label7->Caption);
RangeSecond=StrToFloat(Form1->Label9->Caption);
Prec=StrToFloat(Form1->Label10->Caption);
SubarraySizeStrings=StrToInt(Form1->Label12->Caption);
Form1->SG1->RowCount=SubarraySizeStrings+4;
Form1->SG1->Cells[0][Form1->SG1->RowCount-3]="Max";
Form1->SG1->Cells[0][Form1->SG1->RowCount-2]="Sum";
Form1->SG1->Cells[0][Form1->SG1->RowCount-1]="Aver";
a1=StrToFloat(Form2->Edit1->Text);
b1=StrToFloat(Form2->Edit2->Text);
c1=StrToFloat(Form2->Edit3->Text);
//if(Form1->RadioButton6->Checked==true) {}
diap();
}


void __fastcall TForm1::Button1Click(TObject *Sender)
{IterationNumber+=1;
 inputData();
start(IterationNumber);
Form1->Label1->Caption=IterationNumber;
}
//---------------------------------------------------------------------------

int start(int iter)
{  Form1->Series3->Clear();
if (iter==1)
    {
        generate(a,maxDiapason+1,SubarraySizeStrings,iter);
   // Form1->Series1->Title=Form2->Label1->Caption;
        for (float i=RangeFirst;i<RangeSecond+1;i+=StrToFloat(Form1->Edit1->Text))
        {
            if(Form1->ComboBox1->ItemIndex==0) {
            Form1->Series1->AddXY(i,function1(i),i,clBlue);

             Form1->Series1->Title="y="+FloatToStrF(a1,ffFixed,3,1)+"x^2+"+FloatToStrF(b1,ffFixed,3,1)+"x+"+FloatToStrF(c1,ffFixed,3,1);
            }
            if(Form1->ComboBox1->ItemIndex==1) {
            Form1->Series1->AddXY(i,function2(i),i,clBlue);
             Form1->Series1->Title="y="+FloatToStrF(a1,ffFixed,3,1)+"x^2+"+FloatToStrF(b1,ffFixed,3,1)+"x+sin(x)"+FloatToStrF(c1,ffFixed,3,1);
            }
        }

            if(Form1->ComboBox1->ItemIndex==2)
            {
               for(float i=RangeFirst;i<RangeSecond+1;i+=StrToFloat(Form1->Edit1->Text))
                    {Form1->Series1->AddXY(i,function3(i),i,clBlue);
                    Form1->Series1->Title="y="+FloatToStrF(a1,ffFixed,3,1)+"sin(x)/"+FloatToStrF(b1,ffFixed,3,1)+"cos(x)+exp("+FloatToStrF(c1,ffFixed,3,1)+")";
                    }
            }

        if(Form1->ComboBox1->ItemIndex==3)
        {
            for (float i=RangeFirst;i<RangeSecond+1;i+=StrToFloat(Form1->Edit1->Text))
                {Form1->Series1->AddXY(i,function4(i),i,clBlue);
                Form1->Series1->Title="y=sin(x*"+FloatToStrF(a1,ffFixed,3,1)+")/"+FloatToStrF(b1,ffFixed,3,1)+"*x";
                }
          }
     }

 result(a,B,iter);
 ruletka(B,P,iter);
 reproduction(a,P,Ran,iter);
    Form1->Series2->Clear();
for(int i=1;i<SubarraySizeStrings+1;i++)
    {
    Form1->SG1->Cells[0][i]=i;
    Form1->SG1->Cells[1][i]=binary(a[iter][i],arraySizeGenes);
    Form1->SG1->Cells[2][i]=a[iter][i];
    Form1->SG1->Cells[3][i]=FloatToStrF((float)(RangeSecond-RangeFirst)*a[iter][i]/maxDiapason,ffFixed,3,4);
    Form1->SG1->Cells[4][i]=FloatToStrF(B[iter][i],ffFixed,4,5);
    Form1->SG1->Cells[5][i]=FloatToStrF(P[iter][i],ffFixed,3,4);
    Form1->SG1->Cells[6][i]=binary(a[iter+1][i],arraySizeGenes);
    Form1->SG1->Cells[7][i]=FloatToStrF(Ran[iter][i],ffFixed,3,4);

    Form1->Series2->AddXY((float)(RangeSecond-RangeFirst)*a[iter][i]/maxDiapason,B[iter][i]," ",clBlue);
    }

Form1->SG1->Cells[4][Form1->SG1->RowCount-3]=max(B,iter);
Form1->SG1->Cells[4][Form1->SG1->RowCount-2]=sum(B,iter);
avr[iter]=(float)sum(B,iter)/SubarraySizeStrings;
Form1->SG1->Cells[4][Form1->SG1->RowCount-1]=avr[iter];

Form1->Label15->Caption=FloatToStrF(max2(B),ffFixed,6,3);
 Form1->Label14->Caption=FloatToStrF((float)(RangeSecond-RangeFirst)*a[TheBest][lastMax[TheBest]]/maxDiapason,ffFixed,6,3);
 Form1->Label21->Caption=TheBest;
       Form1->Label14->Visible=true;
    Form1->Label15->Visible=true;

  crossover(a,Cros,CrossPosition,iter);
 for(int i=1;i<SubarraySizeStrings+1;i++)
    {
    Form1->SG1->Cells[8][i]=binary(a[iter+1][i],arraySizeGenes);
    Form1->SG1->Cells[9][i]=FloatToStrF(Cros[iter+1][i],ffFixed,3,4);
    Form1->SG1->Cells[10][i]=CrossPosition[iter+1][i];
    }

mutation(a,MutationProb,iter);
for(int i=1;i<SubarraySizeStrings+1;i++)
    {
    Form1->SG1->Cells[11][i]=binary(a[iter+1][i],arraySizeGenes);
    }

return 0;
}

void generate(int e[][arraySizeStrings+1],int l,int n,int num)
{
    for(int i=1;i<n+1;i++)
        {
        e[num][i]=random(l);
        }
}

float function2(float x)
{return a1*x*x+b1*x*sin(x)+c1;//-(x-4)*(x-4)+3000;
}

float function1(float x)
{return a1*x*x+b1*x+c1;//-(x-4)*(x-4)+3000;
}

float function3(float x)
{return a1*sin(x)/b1*cos(x)+exp(c1);//-(x-4)*(x-4)+3000;
}

float function4(float x)
{return sin(a1*(x+1))/b1*(x+1);
}

float max(float x[][arraySizeStrings+1],int num)
{float hold=-10000;
for(int i=1;i<SubarraySizeStrings+1;i++)
if(x[num][i]>hold) {hold=x[num][i];
lastMax[num]=i;}

//if(x[lastMax[num]][num]>TheBest) {TheBest=x[lastMax[num]][num];
//TheBestIter=a[lastMax[num]][num];
// }

return hold;
}

float max2(float ma[][arraySizeStrings+1])
{float hold=-110;
for(int i=1;i<IterationNumber+1;i++)
if(ma[i][lastMax[i]]>hold) {hold=ma[i][lastMax[i]]; TheBest=i;}
return hold;
}

float sum(float x[][arraySizeStrings+1],int num)
{
float sum=0;
for(int i=1;i<SubarraySizeStrings+1;i++)
{sum=sum+x[num][i];}
return sum;
}

void result(int from[][arraySizeStrings+1],float where[][arraySizeStrings+1],int num)
{for(int i=1;i<SubarraySizeStrings+1;i++)

{
    if(Form1->ComboBox1->ItemIndex==0) {
        where[num][i]=function1((float)(RangeSecond-RangeFirst)*from[num][i]/maxDiapason);
        }
    if(Form1->ComboBox1->ItemIndex==1) {
        where[num][i]=function2((float)(RangeSecond-RangeFirst)*from[num][i]/maxDiapason);
        }
    if(Form1->ComboBox1->ItemIndex==2){
        where[num][i]=function3((float)(RangeSecond-RangeFirst)*from[num][i]/maxDiapason);
        }

    if(Form1->ComboBox1->ItemIndex==3) {
        where[num][i]=function4((float)(RangeSecond-RangeFirst)*from[num][i]/maxDiapason);
        }
}
}

void ruletka(float from[][arraySizeStrings+1],float res[][arraySizeStrings+1],int num)
{res[num][0]=0;
float summa=sum(from,num);
for(int i=1;i<SubarraySizeStrings+1;i++)
{res[num][i]=res[num][i-1]+(float)from[num][i]/summa;
}
}


void reproduction(int aa[][arraySizeStrings+1],float prob[][arraySizeStrings+1],float ra[][arraySizeStrings+1],int num)
{ randomize();
for(int j=1;j<SubarraySizeStrings+1;j++)
 { float x=(float)rand()/RAND_MAX; ra[num][j]=x;
    for(int i=1;i<SubarraySizeStrings+1;i++)
        {if((x>=prob[num][i-1]) && (x<prob[num][i]))
            {aa[num+1][j]=aa[num][i];break;}
} }
}


void __fastcall TForm1::Button2Click(TObject *Sender)
{
back(IterationNumber-1);
Form1->Label1->Caption=IterationNumber;
}
//---------------------------------------------------------------------------
void back(int iter)
{
for(int i=1;i<SubarraySizeStrings+1;i++)
    {
    Form1->SG1->Cells[0][i]=i;
    Form1->SG1->Cells[1][i]=binary(a[iter][i],arraySizeGenes);
    Form1->SG1->Cells[2][i]=a[iter][i];
    Form1->SG1->Cells[3][i]=(RangeSecond-RangeFirst)*a[iter][i]/maxDiapason;
    Form1->SG1->Cells[4][i]=B[iter][i];
    Form1->SG1->Cells[5][i]=FloatToStrF(P[iter][i],ffFixed,3,4);
    Form1->SG1->Cells[6][i]=binary(a[iter+1][i],arraySizeGenes);
    Form1->SG1->Cells[7][i]=FloatToStrF(Ran[iter][i],ffFixed,3,4);
    }

Form1->SG1->Cells[4][Form1->SG1->RowCount-3]=max(B,iter);
Form1->SG1->Cells[4][Form1->SG1->RowCount-2]=sum(B,iter);
Form1->SG1->Cells[4][Form1->SG1->RowCount-1]=avr[iter];
}


void crossover(int x[][arraySizeStrings+1],float z[][arraySizeStrings+1],int c[][arraySizeStrings+1],int num)
{
    for (int i=1;i<SubarraySizeStrings;i+=2)
    {float y=(float)rand()/RAND_MAX; int hold;
        z[num+1][i]=y;z[num+1][i+1]=y;
        if(y<cross_Prob)
            {
            int cr=(1+random(5)); c[num+1][i]=cr; c[num+1][i+1]=cr;
            for(int j=cr;j<arraySizeGenes;j++)
                {if((x[num+1][i] & (Maska>>j))==0)
                    {hold=0;}
                else {hold=1;}

                if((x[num+1][i+1] & (Maska>>j))==0)
                    {x[num+1][i]=(x[num+1][i] & (~Maska>>j));}
                else {x[num+1][i]=(x[num+1][i] | (Maska>>j));}

                if(hold==0)
                    {x[num+1][i+1]=(x[num+1][i+1] & (~Maska>>j));}
                else{x[num+1][i+1]=(x[num+1][i+1] | (Maska>>j));}
                }// end for
          }//end if
    }//end for
 } //end crossover

 void mutation(int xi[][arraySizeStrings+1],float pr[][arraySizeStrings+1][16],int num)
 {for(int i=1;i<SubarraySizeStrings+1;i++)
    for(int j=0;j<arraySizeGenes;j++)
        {float x=(float)rand()/RAND_MAX; pr[num+1][i][j+1]=x;
                if(x<mut_Prob)
                {
                    if((xi[num+1][i] & (Maska>>j))==0)
                        {xi[num+1][i]=(xi[num+1][i] | (Maska>>j));}
                    else{xi[num+1][i]=(xi[num+1][i] & (~Maska>>j));}
                } // end if
        } // end for
} //end mutation


void __fastcall TForm1::Button3Click(TObject *Sender)
{Application->Terminate();}
//---------------------------------------------------------------------------

void __fastcall TForm1::Change(TObject *Sender)
{Form1->Label2->Caption = FloatToStrF((float)Form1->ScrollBar1->Position/1000,ffFixed,6,3);}

void __fastcall TForm1::change2(TObject *Sender)
{Form1->Label3->Caption = FloatToStrF((float)Form1->ScrollBar2->Position/1000,ffFixed,6,3);}

void __fastcall TForm1::ScrollBar7Change(TObject *Sender)
{Form1->Label10->Caption = FloatToStrF((float)Form1->ScrollBar7->Position/1000,ffFixed,6,3);}

void __fastcall TForm1::ScrollBar5Change(TObject *Sender)
{ Form1->Label7->Caption = Form1->ScrollBar5->Position;}

void __fastcall TForm1::ScrollBar3Change(TObject *Sender)
{ Form1->Label9->Caption = Form1->ScrollBar3->Position;}

void __fastcall TForm1::ScrollBar4Change(TObject *Sender)
{Form1->Label12->Caption = Form1->ScrollBar4->Position;}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{ int k=201;
 k=StrToInt(Edit2->Text);
   // else{k=201;}
    inputData();
    for(IterationNumber;IterationNumber<k;IterationNumber++)
       start(IterationNumber);
       // {if(start(IterationNumber)==-1) break;}
        Form1->Label1->Caption=IterationNumber;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
IterationNumber=0;
Form1->Label1->Caption=IterationNumber;
for(int i=1;i<Form1->SG1->RowCount+1;i++)
    for(int j=0;j<12;j++)
    Form1->SG1->Cells[j][i]="";

    Form1->Series1->Clear();
    Form1->Series2->Clear();


Form1->Label14->Visible=false;
Form1->Label15->Visible=false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
if(Form1->ComboBox1->ItemIndex==0) {Form2->Label1->Caption=Form1->ComboBox1->Items->Strings[0];}
if(Form1->ComboBox1->ItemIndex==1) {Form2->Label1->Caption=Form1->ComboBox1->Items->Strings[1];}
if(Form1->ComboBox1->ItemIndex==2) {Form2->Label1->Caption=Form1->ComboBox1->Items->Strings[2];}
if(Form1->ComboBox1->ItemIndex==3) {Form2->Label1->Caption=Form1->ComboBox1->Items->Strings[3];}
Form2->Show();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::get3(TCustomSeries *Sender, int ValueIndex, int X,
      int Y)
{ 
Form1->Series3->Clear();
Form1->Series3->AddXY(Form1->Series2->XValue[ValueIndex],Form1->Series2->YValue[ValueIndex]," ",clBlue);

}
//---------------------------------------------------------------------------

